library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

ENTITY TX IS
PORT ( 
CLK: IN std_logic;
START: IN std_logic;
BUSY: OUT std_logic;
DATA: IN std_logic_vector (7 downto 0);
TX_LINE: OUT std_logic
);
END TX;

ARCHITECTURE MAIN OF TX IS

SIGNAL PRSCL: integer RANGE 0 to 5208:=0;
SIGNAL INDEX: integer RANGE 0 to 9:=0;
SIGNAL DATAFLL: std_logic_vector (9 downto 0);
SIGNAL TX_FLG: std_logic :='0';
BEGIN

PROCESS (CLK)
BEGIN
IF (CLK'EVENT AND CLK='1') THEN
TX_FLG<='1';
BUSY<='1';
DATAFLL(0)<='0';
DATAFLL (9)<='1';
DATAFLL (8 downto 1) <= DATA;
END IF;
IF (TX_FLG='1') THEN
IF (PRSCL <= 5207) THEN
PRSCL <= PRSCL+1;
ELSE
PRSCL<=0;
END IF;
IF (PRSCL <= 2607) THEN
TX_LINE <= DATAFLL (INDEX);
IF (INDEX<9)THEN
INDEX<=INDEX +1;
ELSE
TX_FLG <='0';
BUSY<='0';
INDEX <=0;
END IF;
END IF;
END IF;
END PROCESS;
END MAIN;


